<script setup lang="ts">
import { computed, type PropType } from "vue";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import ParameterDescription from "@/components/parameter-schema/description-mode/ParameterDescription.vue";
import { type ParameterCombinationDependencies } from "@/types/WorkflowParameters.ts";
import {
  ParameterVisibility,
  type ParameterVisibilityMapping,
} from "@/client/types.gen.ts";

const props = defineProps({
  parameterGroupName: {
    type: String,
    required: true,
  },
  schemaProperties: {
    type: Object,
    required: true,
  },
  resourceParameters: {
    type: Array as PropType<string[]>,
    required: false,
  },
  parameterVisibility: {
    type: Object as PropType<ParameterVisibilityMapping>,
    required: true,
  },
  currentVisibility: {
    type: Number,
    default: ParameterVisibility.SIMPLE,
  },
});

const title = computed<string>(() => parameterGroup.value["title"]);
const icon = computed<string>(() => parameterGroup.value["fa_icon"]);
const description = computed<string>(() => parameterGroup.value["description"]);
const parameters = computed<Record<string, never>>(
  () => parameterGroup.value["properties"],
);

const parameterGroup = computed(
  () => props.schemaProperties[props.parameterGroupName],
);

/*
Object with parameter name as key and list of parameters that make the parameter required if they are set as value
JSONSchema DependentRequired
 */
const parameterDependenciesPerParameter = computed<Record<string, string[]>>(
  () => {
    const r: Record<string, string[]> = {};
    for (const groupName of Object.keys(props.schemaProperties)) {
      const dep =
        props.schemaProperties[groupName]["dependentRequired"] ??
        props.schemaProperties[groupName]["dependencies"] ??
        {};
      for (const paramName of Object.keys(dep)) {
        for (const depParam of dep[paramName]) {
          if (parameters.value[depParam] != undefined) {
            if (r[depParam] == undefined) {
              r[depParam] = [paramName];
            } else {
              r[depParam].push(depParam);
            }
          }
        }
      }
    }
    return r;
  },
);

// object with parameter name as key and anyOf dependencies as value
const parameterAnyOfDependenciesPerParameter = computed<
  Record<string, ParameterCombinationDependencies>
>(() => {
  const b: string[][] =
    parameterGroup.value["anyOf"]
      ?.map((b: Record<string, string[]>) => b["required"] ?? [])
      ?.filter((b: string[]) => b.length > 0) ?? [];
  const r: Record<string, ParameterCombinationDependencies> = {};
  for (const paramName of b.flat()) {
    r[paramName] = {
      group:
        b.find((a) => a.includes(paramName))?.filter((a) => a != paramName) ??
        [],
      dependencies: b.filter((a) => !a.includes(paramName)),
    };
  }
  return r;
});

// object with parameter name as key and anyOf dependencies as value
const parameterOneOfDependenciesPerParameter = computed<
  Record<string, ParameterCombinationDependencies>
>(() => {
  const b: string[][] =
    parameterGroup.value["oneOf"]
      ?.map((b: Record<string, string[]>) => b["required"] ?? [])
      ?.filter((b: string[]) => b.length > 0) ?? [];
  const r: Record<string, ParameterCombinationDependencies> = {};
  for (const paramName of b.flat()) {
    r[paramName] = {
      group:
        b.find((a) => a.includes(paramName))?.filter((a) => a != paramName) ??
        [],
      dependencies: b.filter((a) => !a.includes(paramName)),
    };
  }
  return r;
});

function parameterVisible(paramName: string): boolean {
  return props.parameterVisibility[paramName] <= props.currentVisibility;
}

const groupHidden = computed<boolean>(() =>
  Object.keys(parameters.value).reduce(
    (acc: boolean, val: string) => acc && !parameterVisible(val),
    true,
  ),
);
</script>

<template>
  <div :hidden="groupHidden" class="mb-5">
    <div class="row">
      <h2 :id="props.parameterGroupName">
        <font-awesome-icon v-if="icon" :icon="icon" class="me-3" />
        {{ title }}
      </h2>
      <h4>{{ description }}</h4>
    </div>
    <template
      v-for="(parameter, parameterName) in parameters"
      :key="parameterName"
    >
      <parameter-description
        v-if="parameter['type'] !== 'object'"
        :hidden="!parameterVisible(parameterName)"
        :parameter-name="parameterName"
        :parameter="parameter"
        :required="parameterGroup['required']?.includes(parameterName) ?? false"
        :clowm-resource="resourceParameters?.includes(parameterName)"
        :dependencies="parameterDependenciesPerParameter[parameterName]"
        :any-of-dependencies="
          parameterAnyOfDependenciesPerParameter[parameterName]
        "
        :one-of-dependencies="
          parameterOneOfDependenciesPerParameter[parameterName]
        "
      />
    </template>
  </div>
</template>

<style scoped></style>
